/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal.js";
export const protobufPackage = "google.protobuf";
function createBaseTimestamp() {
    return { seconds: Long.ZERO, nanos: 0 };
}
export const Timestamp = {
    encode(message, writer = _m0.Writer.create()) {
        if (!message.seconds.isZero()) {
            writer.uint32(8).int64(message.seconds);
        }
        if (message.nanos !== 0) {
            writer.uint32(16).int32(message.nanos);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseTimestamp();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 8) {
                        break;
                    }
                    message.seconds = reader.int64();
                    continue;
                case 2:
                    if (tag !== 16) {
                        break;
                    }
                    message.nanos = reader.int32();
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    // encodeTransform encodes a source of message objects.
    // Transform<Timestamp, Uint8Array>
    async *encodeTransform(source) {
        for await (const pkt of source) {
            if (globalThis.Array.isArray(pkt)) {
                for (const p of pkt) {
                    yield* [Timestamp.encode(p).finish()];
                }
            }
            else {
                yield* [Timestamp.encode(pkt).finish()];
            }
        }
    },
    // decodeTransform decodes a source of encoded messages.
    // Transform<Uint8Array, Timestamp>
    async *decodeTransform(source) {
        for await (const pkt of source) {
            if (globalThis.Array.isArray(pkt)) {
                for (const p of pkt) {
                    yield* [Timestamp.decode(p)];
                }
            }
            else {
                yield* [Timestamp.decode(pkt)];
            }
        }
    },
    fromJSON(object) {
        return {
            seconds: isSet(object.seconds) ? Long.fromValue(object.seconds) : Long.ZERO,
            nanos: isSet(object.nanos) ? globalThis.Number(object.nanos) : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        if (!message.seconds.isZero()) {
            obj.seconds = (message.seconds || Long.ZERO).toString();
        }
        if (message.nanos !== 0) {
            obj.nanos = Math.round(message.nanos);
        }
        return obj;
    },
    create(base) {
        return Timestamp.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseTimestamp();
        message.seconds = (object.seconds !== undefined && object.seconds !== null)
            ? Long.fromValue(object.seconds)
            : Long.ZERO;
        message.nanos = object.nanos ?? 0;
        return message;
    },
};
if (_m0.util.Long !== Long) {
    _m0.util.Long = Long;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
